# NanoBlogger List Entries Plugin
# List Recent entries
#
# sample code for templates, based off the default stylesheet
#
# <div class="sidetitle">
# Recent Entries/Older Entries
# </div>
# <div class="side">
# $NB_Recent_Entries/$NB_Older_Entries
# </div>

# set how many entries to list
LIST_N="10"
LIST_OFFSET="1"

OUTPUT_FILE1="$BLOG_DIR/$PARTS_DIR/recent_entries.htm"
OUTPUT_FILE2="$BLOG_DIR/$PARTS_DIR/older_entries.htm"

get_entries(){
LIST_MODE="$1"
FILE="$2"
[ "$LIST_MODE" = "new" ] && query_db limit nocat "$LIST_N"
if [ "$LIST_MODE" = "old" ]; then
	LIST_OFFSET="$LIST_N"
	LIST_N=`expr $LIST_N + $LIST_N`
	query_db limit nocat "$LIST_N" "$LIST_OFFSET"
fi
echo "" > "$FILE"
for entry in $DB_RESULTS ; do
	read_metadata TITLE "$NB_DATA_DIR/$entry"; NB_EntryTitle="$NB_Metadata"
	NB_EntryID="$x_id$entry"
	title_link="$NB_EntryTitle"
	if [ "$ENTRY_ARCHIVES" = "1" ] ; then
		permalink_entry=`chg_suffix $entry`
		permalink="$BLOG_URL/$PERMALINKS_DIR/$permalink_entry"
	else
		month_link=`echo "$entry" |cut -c1-7`
		permalink="$BLOG_URL/$MONTHLY_DIR/$month_link.$NB_FILETYPE#$NB_EntryID"
	fi
	if [ -z "$title_link" ] ; then title_link="Untitled" ; fi
	cat >> "$FILE" <<-EOF 
		<a href="$permalink">$title_link</a><br />
	EOF
done
}

get_entries new "$OUTPUT_FILE1"
NB_Recent_Entries=`cat "$OUTPUT_FILE1"`

get_entries old "$OUTPUT_FILE2"
NB_Older_Entries=`cat "$OUTPUT_FILE2"`
